Index: codes/icosagcm/trunk/src/advect.f90
===================================================================
--- codes/icosagcm/trunk/src/advect.f90	(revision 185)
+++ codes/icosagcm/trunk/src/advect.f90	(revision 186)
@@ -49,11 +49,13 @@
   !=======================================================================================
 
-  SUBROUTINE compute_gradq3d(qi,one_over_sqrt_leng,gradq3d)
+  SUBROUTINE compute_gradq3d(qi_in,one_over_sqrt_leng_in,gradq3d_out,xyz_i,xyz_v)
     USE trace
     USE omp_para
     IMPLICIT NONE
-    REAL(rstd),INTENT(IN)  :: qi(iim*jjm,llm)
-    REAL(rstd),INTENT(IN)  :: one_over_sqrt_leng(iim*jjm)
-    REAL(rstd),INTENT(OUT) :: gradq3d(iim*jjm,llm,3) 
+    REAL(rstd),INTENT(IN)  :: qi_in(iim*jjm,llm)
+    REAL(rstd),INTENT(IN)  :: one_over_sqrt_leng_in(iim*jjm)
+    REAL(rstd),INTENT(IN)  :: xyz_i(iim*jjm,3)
+    REAL(rstd),INTENT(IN)  :: xyz_v(2*iim*jjm,3)
+    REAL(rstd),INTENT(OUT) :: gradq3d_out(iim*jjm,llm,3) 
     REAL(rstd) :: maxq,minq,minq_c,maxq_c 
     REAL(rstd) :: alphamx,alphami,alpha	,maggrd
@@ -63,6 +65,16 @@
     REAL(rstd) :: gradtri(2*iim*jjm,llm,3) 
     INTEGER :: ij,k,ind,l
-
-    CALL trace_start("compute_gradq3d")
+    REAL(rstd)  :: qi(iim*jjm,llm)
+    REAL(rstd)  :: one_over_sqrt_leng(iim*jjm)
+    REAL(rstd) :: gradq3d(iim*jjm,llm,3) 
+    REAL(rstd) :: detx,dety,detz,det
+    REAL(rstd) :: A(3,3), a11,a12,a13,a21,a22,a23,a31,a32,a33
+    REAL(rstd) :: x1,x2,x3
+    REAL(rstd) :: dq(3)
+
+    qi=qi_in
+    one_over_sqrt_leng=one_over_sqrt_leng_in
+    
+    CALL trace_start("compute_gradq3d1")
 
     ! TODO : precompute ar, drop arr as output argument of gradq ?
@@ -71,16 +83,152 @@
     ! Compute gradient at triangles solving a linear system
     ! arr = area of triangle joining centroids of hexagons
+!     DO l = ll_begin,ll_end 
+!!$SIMD
+!      DO ij=ij_begin_ext,ij_end_ext
+!!             CALL gradq(ij,l,ij+t_rup,ij+t_lup,ij+z_up,qi,gradtri(ij+z_up,l,:),arr(ij+z_up))
+!!             CALL gradq(ij,l,ij+t_ldown,ij+t_rdown,ij+z_down,qi,gradtri(ij+z_down,l,:),arr(ij+z_down))
+!             CALL gradq(ij,l,ij+t_rup,ij+t_lup,ij+z_up,qi,gradtri(ij+z_up,l,1),gradtri(ij+z_up,l,2),gradtri(ij+z_up,l,3),arr(ij+z_up))
+!             CALL gradq(ij,l,ij+t_ldown,ij+t_rdown,ij+z_down,qi,gradtri(ij+z_down,l,1),gradtri(ij+z_down,l,2),gradtri(ij+z_down,l,3),arr(ij+z_down))
+!       END DO
+!    END DO
+
      DO l = ll_begin,ll_end 
 !$SIMD
       DO ij=ij_begin_ext,ij_end_ext
-             CALL gradq(ij,l,ij+t_rup,ij+t_lup,ij+z_up,qi,gradtri(ij+z_up,l,:),arr(ij+z_up))
-             CALL gradq(ij,l,ij+t_ldown,ij+t_rdown,ij+z_down,qi,gradtri(ij+z_down,l,:),arr(ij+z_down))
-       END DO
+!       CALL gradq(ij,l,ij+t_rup,ij+t_lup,ij+z_up,qi,gradtri(ij+z_up,l,1),gradtri(ij+z_up,l,2),gradtri(ij+z_up,l,3),arr(ij+z_up))
+
+        
+        A(1,1)=xyz_i(ij+t_rup,1)-xyz_i(ij,1);  A(1,2)=xyz_i(ij+t_rup,2)-xyz_i(ij,2); A(1,3)=xyz_i(ij+t_rup,3)-xyz_i(ij,3) 
+        A(2,1)=xyz_i(ij+t_lup,1)-xyz_i(ij,1);  A(2,2)=xyz_i(ij+t_lup,2)-xyz_i(ij,2); A(2,3)=xyz_i(ij+t_lup,3)-xyz_i(ij,3) 
+        A(3,1)=xyz_v(ij+z_up,1);               A(3,2)= xyz_v(ij+z_up,2);             A(3,3)=xyz_v(ij+z_up,3)
+    
+        dq(1) = qi(ij+t_rup,l)-qi(ij,l)
+        dq(2) = qi(ij+t_lup,l)-qi(ij,l)
+        dq(3) = 0.0
+
+
+!        CALL determinant(A(1,1),A(2,1),A(3,1),A(1,2),A(2,2),A(3,2),A(1,3),A(2,3),A(3,3),det)
+
+         a11=A(1,1) ; a12=A(2,1) ; a13=A(3,1)
+         a21=A(1,2) ; a22=A(2,2) ; a23=A(3,2)
+         a31=A(1,3) ; a32=A(2,3) ; a33=A(3,3)
+
+         x1 =  a11 * (a22 * a33 - a23 * a32)
+         x2 =  a12 * (a21 * a33 - a23 * a31)
+         x3 =  a13 * (a21 * a32 - a22 * a31)
+         det =  x1 - x2 + x3
+                 
+!        CALL determinant(dq(1),dq(2),dq(3),A(1,2),A(2,2),A(3,2),A(1,3),A(2,3),A(3,3),detx)
+
+         a11=dq(1)  ; a12=dq(2)  ; a13=dq(3)
+         a21=A(1,2) ; a22=A(2,2) ; a23=A(3,2)
+         a31=A(1,3) ; a32=A(2,3) ; a33=A(3,3)
+
+         x1 =  a11 * (a22 * a33 - a23 * a32)
+         x2 =  a12 * (a21 * a33 - a23 * a31)
+         x3 =  a13 * (a21 * a32 - a22 * a31)
+         detx =  x1 - x2 + x3
+        
+!        CALL determinant(A(1,1),A(2,1),A(3,1),dq(1),dq(2),dq(3),A(1,3),A(2,3),A(3,3),dety)
+
+         a11=A(1,1) ; a12=A(2,1) ; a13=A(3,1)
+         a21=dq(1)  ; a22=dq(2)  ; a23=dq(3)
+         a31=A(1,3) ; a32=A(2,3) ; a33=A(3,3)
+
+         x1 =  a11 * (a22 * a33 - a23 * a32)
+         x2 =  a12 * (a21 * a33 - a23 * a31)
+         x3 =  a13 * (a21 * a32 - a22 * a31)
+         dety =  x1 - x2 + x3
+
+!        CALL determinant(A(1,1),A(2,1),A(3,1),A(1,2),A(2,2),A(3,2),dq(1),dq(2),dq(3),detz)
+
+         a11=A(1,1) ; a12=A(2,1) ; a13=A(3,1)
+         a21=A(1,2) ; a22=A(2,2) ; a23=A(3,2)
+         a31=dq(1)  ; a32=dq(2)  ; a33=dq(3)
+
+         x1 =  a11 * (a22 * a33 - a23 * a32)
+         x2 =  a12 * (a21 * a33 - a23 * a31)
+         x3 =  a13 * (a21 * a32 - a22 * a31)
+         detz =  x1 - x2 + x3
+
+        gradtri(ij+z_up,l,1) = detx
+        gradtri(ij+z_up,l,2) = dety
+        gradtri(ij+z_up,l,3) = detz
+        arr(ij+z_up) = det
+        
+      ENDDO
+      
+      DO ij=ij_begin_ext,ij_end_ext
+
+
+!        CALL gradq(ij,l,ij+t_ldown,ij+t_rdown,ij+z_down,qi,gradtri(ij+z_down,l,1),gradtri(ij+z_down,l,2),gradtri(ij+z_down,l,3),arr(ij+z_down))
+
+        A(1,1)=xyz_i(ij+t_ldown,1)-xyz_i(ij,1);  A(1,2)=xyz_i(ij+t_ldown,2)-xyz_i(ij,2); A(1,3)=xyz_i(ij+t_ldown,3)-xyz_i(ij,3) 
+        A(2,1)=xyz_i(ij+t_rdown,1)-xyz_i(ij,1);  A(2,2)=xyz_i(ij+t_rdown,2)-xyz_i(ij,2); A(2,3)=xyz_i(ij+t_rdown,3)-xyz_i(ij,3) 
+        A(3,1)=xyz_v(ij+z_down,1);               A(3,2)= xyz_v(ij+z_down,2);             A(3,3)=xyz_v(ij+z_down,3)
+ 
+        dq(1) = qi(ij+t_ldown,l)-qi(ij,l)
+        dq(2) = qi(ij+t_rdown,l)-qi(ij,l)
+        dq(3) = 0.0
+
+
+!        CALL determinant(A(1,1),A(2,1),A(3,1),A(1,2),A(2,2),A(3,2),A(1,3),A(2,3),A(3,3),det)
+
+         a11=A(1,1) ; a12=A(2,1) ; a13=A(3,1)
+         a21=A(1,2) ; a22=A(2,2) ; a23=A(3,2)
+         a31=A(1,3) ; a32=A(2,3) ; a33=A(3,3)
+
+         x1 =  a11 * (a22 * a33 - a23 * a32)
+         x2 =  a12 * (a21 * a33 - a23 * a31)
+         x3 =  a13 * (a21 * a32 - a22 * a31)
+         det =  x1 - x2 + x3
+                 
+!        CALL determinant(dq(1),dq(2),dq(3),A(1,2),A(2,2),A(3,2),A(1,3),A(2,3),A(3,3),detx)
+
+         a11=dq(1)  ; a12=dq(2)  ; a13=dq(3)
+         a21=A(1,2) ; a22=A(2,2) ; a23=A(3,2)
+         a31=A(1,3) ; a32=A(2,3) ; a33=A(3,3)
+
+         x1 =  a11 * (a22 * a33 - a23 * a32)
+         x2 =  a12 * (a21 * a33 - a23 * a31)
+         x3 =  a13 * (a21 * a32 - a22 * a31)
+         detx =  x1 - x2 + x3
+        
+!        CALL determinant(A(1,1),A(2,1),A(3,1),dq(1),dq(2),dq(3),A(1,3),A(2,3),A(3,3),dety)
+
+         a11=A(1,1) ; a12=A(2,1) ; a13=A(3,1)
+         a21=dq(1)  ; a22=dq(2)  ; a23=dq(3)
+         a31=A(1,3) ; a32=A(2,3) ; a33=A(3,3)
+
+         x1 =  a11 * (a22 * a33 - a23 * a32)
+         x2 =  a12 * (a21 * a33 - a23 * a31)
+         x3 =  a13 * (a21 * a32 - a22 * a31)
+         dety =  x1 - x2 + x3
+
+!        CALL determinant(A(1,1),A(2,1),A(3,1),A(1,2),A(2,2),A(3,2),dq(1),dq(2),dq(3),detz)
+
+         a11=A(1,1) ; a12=A(2,1) ; a13=A(3,1)
+         a21=A(1,2) ; a22=A(2,2) ; a23=A(3,2)
+         a31=dq(1)  ; a32=dq(2)  ; a33=dq(3)
+
+         x1 =  a11 * (a22 * a33 - a23 * a32)
+         x2 =  a12 * (a21 * a33 - a23 * a31)
+         x3 =  a13 * (a21 * a32 - a22 * a31)
+         detz =  x1 - x2 + x3
+
+         gradtri(ij+z_down,l,1) = detx
+         gradtri(ij+z_down,l,2) = dety
+         gradtri(ij+z_down,l,3) = detz
+         arr(ij+z_down) = det
+
+      END DO
     END DO
 
 !$SIMD
-      DO ij=ij_begin,ij_end
-         ar(ij) = arr(ij+z_up)+arr(ij+z_lup)+arr(ij+z_ldown)+arr(ij+z_down)+arr(ij+z_rdown)+arr(ij+z_rup)+1.e-50
+    DO ij=ij_begin,ij_end
+       ar(ij) = arr(ij+z_up)+arr(ij+z_lup)+arr(ij+z_ldown)+arr(ij+z_down)+arr(ij+z_rdown)+arr(ij+z_rup)+1.e-50
     ENDDO
+    CALL trace_end("compute_gradq3d1")
+    CALL trace_start2("compute_gradq3d2")
       
     DO k=1,3
@@ -94,4 +242,6 @@
       END DO
     ENDDO
+    CALL trace_end2("compute_gradq3d2")
+    CALL trace_start("compute_gradq3d3")
 
     !============================================================================================= LIMITING 
@@ -99,5 +249,6 @@
 !$SIMD
       DO ij=ij_begin,ij_end
-             maggrd =  dot_product(gradq3d(ij,l,:),gradq3d(ij,l,:))
+!             maggrd =  dot_product(gradq3d(ij,l,:),gradq3d(ij,l,:))
+             maggrd = gradq3d(ij,l,1)*gradq3d(ij,l,1) + gradq3d(ij,l,2)*gradq3d(ij,l,2) + gradq3d(ij,l,3)*gradq3d(ij,l,3) 
              maggrd = sqrt(maggrd) 
              maxq_c = qi(ij,l) + maggrd*one_over_sqrt_leng(ij)
@@ -112,9 +263,81 @@
              alphami = max(alphami,0.0) 
              alpha   = min(alphamx,alphami,1.0)
-             gradq3d(ij,l,:) = alpha*gradq3d(ij,l,:)
+!             gradq3d(ij,l,:) = alpha*gradq3d(ij,l,:)
+             gradq3d(ij,l,1) = alpha*gradq3d(ij,l,1)
+             gradq3d(ij,l,2) = alpha*gradq3d(ij,l,2)
+             gradq3d(ij,l,3) = alpha*gradq3d(ij,l,3)
        END DO
     END DO
 
-  CALL trace_end("compute_gradq3d")
+  CALL trace_end("compute_gradq3d3")
+  
+  gradq3d_out=gradq3d
+  
+  CONTAINS
+
+    SUBROUTINE gradq(n0,l,n1,n2,n3,q,dq1,dq2,dq3,det)
+    IMPLICIT NONE
+    INTEGER, INTENT(IN) :: n0,l,n1,n2,n3
+    REAL(rstd), INTENT(IN)     :: q(iim*jjm,llm)
+!    REAL(rstd), INTENT(OUT)    :: dq(3), det
+    REAL(rstd), INTENT(OUT)    :: dq1,dq2,dq3,det
+    REAL(rstd)    :: dq(3)
+    
+    REAL(rstd)  ::detx,dety,detz
+    INTEGER    :: info
+    INTEGER    :: IPIV(3)
+
+    REAL(rstd) :: A(3,3)
+    REAL(rstd) :: B(3)
+    
+    ! TODO : replace A by A1,A2,A3
+    A(1,1)=xyz_i(n1,1)-xyz_i(n0,1);  A(1,2)=xyz_i(n1,2)-xyz_i(n0,2); A(1,3)=xyz_i(n1,3)-xyz_i(n0,3) 
+    A(2,1)=xyz_i(n2,1)-xyz_i(n0,1);  A(2,2)=xyz_i(n2,2)-xyz_i(n0,2); A(2,3)=xyz_i(n2,3)-xyz_i(n0,3) 
+    A(3,1)=xyz_v(n3,1);              A(3,2)= xyz_v(n3,2);            A(3,3)=xyz_v(n3,3)
+
+    dq(1) = q(n1,l)-q(n0,l)
+    dq(2) = q(n2,l)-q(n0,l)
+    dq(3) = 0.0
+
+    !    CALL DGESV(3,1,A,3,IPIV,dq(:),3,info)
+!    CALL determinant(A(:,1),A(:,2),A(:,3),det)
+!    CALL determinant(dq,A(:,2),A(:,3),detx)
+!    CALL determinant(A(:,1),dq,A(:,3),dety)
+!    CALL determinant(A(:,1),A(:,2),dq,detz)
+!    dq(1) = detx
+!    dq(2) = dety
+!    dq(3) = detz 
+
+    CALL determinant(A(1,1),A(2,1),A(3,1),A(1,2),A(2,2),A(3,2),A(1,3),A(2,3),A(3,3),det)
+    CALL determinant(dq(1),dq(2),dq(3),A(1,2),A(2,2),A(3,2),A(1,3),A(2,3),A(3,3),dq1)
+    CALL determinant(A(1,1),A(2,1),A(3,1),dq(1),dq(2),dq(3),A(1,3),A(2,3),A(3,3),dq2)
+    CALL determinant(A(1,1),A(2,1),A(3,1),A(1,2),A(2,2),A(3,2),dq(1),dq(2),dq(3),dq3)
+
+  END SUBROUTINE gradq
+
+  !==========================================================================
+!  PURE SUBROUTINE determinant(a1,a2,a3,det)
+!    IMPLICIT NONE
+!    REAL(rstd), DIMENSION(3), INTENT(IN) :: a1,a2,a3
+!    REAL(rstd), INTENT(OUT) :: det
+!    REAL(rstd) ::  x1,x2,x3
+!    x1 =  a1(1) * (a2(2) * a3(3) - a2(3) * a3(2))
+!    x2 =  a1(2) * (a2(1) * a3(3) - a2(3) * a3(1))
+!    x3 =  a1(3) * (a2(1) * a3(2) - a2(2) * a3(1))
+!    det =  x1 - x2 + x3
+!  END SUBROUTINE determinant
+
+   SUBROUTINE determinant(a11,a12,a13,a21,a22,a23,a31,a32,a33,det)
+    IMPLICIT NONE
+    REAL(rstd), INTENT(IN) :: a11,a12,a13,a21,a22,a23,a31,a32,a33
+    REAL(rstd), INTENT(OUT) :: det
+    REAL(rstd) ::  x1,x2,x3
+    x1 =  a11 * (a22 * a33 - a23 * a32)
+    x2 =  a12 * (a21 * a33 - a23 * a31)
+    x3 =  a13 * (a21 * a32 - a22 * a31)
+    det =  x1 - x2 + x3
+  END SUBROUTINE determinant
+
+
   END SUBROUTINE compute_gradq3d
 
@@ -222,8 +445,10 @@
              IF (ne(ij,right)*hfluxt(ij+u_right,l)>0) THEN 
                 ed = cc(ij+u_right,l,:) - xyz_i(ij,:)
-                qe = qi(ij,l)+sum2(gradq3d(ij,l,:),ed) 
+!                qe = qi(ij,l)+sum2(gradq3d(ij,l,:),ed) 
+                 qe = qi(ij,l)+gradq3d(ij,l,1)*ed(1)+gradq3d(ij,l,2)*ed(2)+gradq3d(ij,l,3)*ed(3) 
              ELSE
                 ed = cc(ij+u_right,l,:) - xyz_i(ij+t_right,:)
-                qe = qi(ij+t_right,l)+sum2(gradq3d(ij+t_right,l,:),ed) 
+!                qe = qi(ij+t_right,l)+sum2(gradq3d(ij+t_right,l,:),ed) 
+                qe = qi(ij+t_right,l) + gradq3d(ij+t_right,l,1)*ed(1)+gradq3d(ij+t_right,l,2)*ed(2)+gradq3d(ij+t_right,l,3)*ed(3) 
              ENDIF
              qflux(ij+u_right,l) = hfluxt(ij+u_right,l)*qe
@@ -231,8 +456,10 @@
              IF (ne(ij,lup)*hfluxt(ij+u_lup,l)>0) THEN 
                 ed = cc(ij+u_lup,l,:) - xyz_i(ij,:)
-                qe = qi(ij,l)+sum2(gradq3d(ij,l,:),ed)
+!                qe = qi(ij,l)+sum2(gradq3d(ij,l,:),ed)
+                qe = qi(ij,l)  + gradq3d(ij,l,1)*ed(1)+gradq3d(ij,l,2)*ed(2)+gradq3d(ij,l,3)*ed(3) 
              ELSE
                 ed = cc(ij+u_lup,l,:) - xyz_i(ij+t_lup,:)
-                qe = qi(ij+t_lup,l)+sum2(gradq3d(ij+t_lup,l,:),ed) 
+!                qe = qi(ij+t_lup,l)+sum2(gradq3d(ij+t_lup,l,:),ed) 
+                qe = qi(ij+t_lup,l) + gradq3d(ij+t_lup,l,1)*ed(1)+gradq3d(ij+t_lup,l,2)*ed(2)+gradq3d(ij+t_lup,l,3)*ed(3) 
              ENDIF
              qflux(ij+u_lup,l) = hfluxt(ij+u_lup,l)*qe 
@@ -240,8 +467,10 @@
              IF (ne(ij,ldown)*hfluxt(ij+u_ldown,l)>0) THEN 
                 ed = cc(ij+u_ldown,l,:) - xyz_i(ij,:)
-                qe = qi(ij,l)+sum2(gradq3d(ij,l,:),ed) 
+!                qe = qi(ij,l)+sum2(gradq3d(ij,l,:),ed) 
+                qe = qi(ij,l) + gradq3d(ij,l,1)*ed(1)+gradq3d(ij,l,2)*ed(2)+gradq3d(ij,l,3)*ed(3) 
              ELSE
                 ed = cc(ij+u_ldown,l,:) - xyz_i(ij+t_ldown,:)
-                qe = qi(ij+t_ldown,l)+sum2(gradq3d(ij+t_ldown,l,:),ed) 
+!                qe = qi(ij+t_ldown,l)+sum2(gradq3d(ij+t_ldown,l,:),ed) 
+                qe = qi(ij+t_ldown,l)+gradq3d(ij+t_ldown,l,1)*ed(1)+gradq3d(ij+t_ldown,l,2)*ed(2)+gradq3d(ij+t_ldown,l,3)*ed(3) 
              ENDIF
              qflux(ij+u_ldown,l) = hfluxt(ij+u_ldown,l)*qe
@@ -289,47 +518,4 @@
   END SUBROUTINE compute_advect_horiz
 
-  !==========================================================================
-  PURE SUBROUTINE gradq(n0,l,n1,n2,n3,q,dq,det)
-    IMPLICIT NONE
-    INTEGER, INTENT(IN) :: n0,l,n1,n2,n3
-    REAL(rstd), INTENT(IN)     :: q(iim*jjm,llm)
-    REAL(rstd), INTENT(OUT)    :: dq(3), det
-    
-    REAL(rstd)  ::detx,dety,detz
-    INTEGER    :: info
-    INTEGER    :: IPIV(3)
-
-    REAL(rstd) :: A(3,3)
-    REAL(rstd) :: B(3)
-
-    ! TODO : replace A by A1,A2,A3
-    A(1,1)=xyz_i(n1,1)-xyz_i(n0,1);  A(1,2)=xyz_i(n1,2)-xyz_i(n0,2); A(1,3)=xyz_i(n1,3)-xyz_i(n0,3) 
-    A(2,1)=xyz_i(n2,1)-xyz_i(n0,1);  A(2,2)=xyz_i(n2,2)-xyz_i(n0,2); A(2,3)=xyz_i(n2,3)-xyz_i(n0,3) 
-    A(3,1)=xyz_v(n3,1);              A(3,2)= xyz_v(n3,2);            A(3,3)=xyz_v(n3,3)
-
-    dq(1) = q(n1,l)-q(n0,l)
-    dq(2) = q(n2,l)-q(n0,l)
-    dq(3) = 0.0
-    !    CALL DGESV(3,1,A,3,IPIV,dq(:),3,info)
-    CALL determinant(A(:,1),A(:,2),A(:,3),det)
-    CALL determinant(dq,A(:,2),A(:,3),detx)
-    CALL determinant(A(:,1),dq,A(:,3),dety)
-    CALL determinant(A(:,1),A(:,2),dq,detz)
-    dq(1) = detx
-    dq(2) = dety
-    dq(3) = detz 
-  END SUBROUTINE gradq
-
-  !==========================================================================
-  PURE SUBROUTINE determinant(a1,a2,a3,det)
-    IMPLICIT NONE
-    REAL(rstd), DIMENSION(3), INTENT(IN) :: a1,a2,a3
-    REAL(rstd), INTENT(OUT) :: det
-    REAL(rstd) ::  x1,x2,x3
-    x1 =  a1(1) * (a2(2) * a3(3) - a2(3) * a3(2))
-    x2 =  a1(2) * (a2(1) * a3(3) - a2(3) * a3(1))
-    x3 =  a1(3) * (a2(1) * a3(2) - a2(2) * a3(1))
-    det =  x1 - x2 + x3
-  END SUBROUTINE determinant
 
 END MODULE advect_mod
Index: codes/icosagcm/trunk/src/advect_tracer.f90
===================================================================
--- codes/icosagcm/trunk/src/advect_tracer.f90	(revision 185)
+++ codes/icosagcm/trunk/src/advect_tracer.f90	(revision 186)
@@ -4,19 +4,19 @@
   PRIVATE
 
-  TYPE(t_field),POINTER :: f_normal(:)
-  TYPE(t_field),POINTER :: f_tangent(:)
-  TYPE(t_field),POINTER :: f_gradq3d(:)
-  TYPE(t_field),POINTER :: f_cc(:)  ! starting point of backward-trajectory (Miura approach)
-  TYPE(t_field),POINTER :: f_one_over_sqrt_leng(:)
-
-  TYPE(t_message) :: req_u, req_cc, req_wfluxt, req_q, req_rhodz, req_gradq3d
+  TYPE(t_field),SAVE,POINTER :: f_normal(:)
+  TYPE(t_field),SAVE,POINTER :: f_tangent(:)
+  TYPE(t_field),SAVE,POINTER :: f_gradq3d(:)
+  TYPE(t_field),SAVE,POINTER :: f_cc(:)  ! starting point of backward-trajectory (Miura approach)
+  TYPE(t_field),SAVE,POINTER :: f_one_over_sqrt_leng(:)
+
+  TYPE(t_message),SAVE :: req_u, req_cc, req_wfluxt, req_q, req_rhodz, req_gradq3d
 
   REAL(rstd), PARAMETER :: pente_max=2.0 ! for vlz
 
 ! temporary shared variable for vlz
-  TYPE(t_field),POINTER :: f_dzqw(:)   ! vertical finite difference of q 
-  TYPE(t_field),POINTER :: f_adzqw(:)  ! abs(dzqw)
-  TYPE(t_field),POINTER :: f_dzq(:)    ! limited slope of q
-  TYPE(t_field),POINTER :: f_wq(:)     ! time-integrated flux of q
+  TYPE(t_field),SAVE,POINTER :: f_dzqw(:)   ! vertical finite difference of q 
+  TYPE(t_field),SAVE,POINTER :: f_adzqw(:)  ! abs(dzqw)
+  TYPE(t_field),SAVE,POINTER :: f_dzq(:)    ! limited slope of q
+  TYPE(t_field),SAVE,POINTER :: f_wq(:)     ! time-integrated flux of q
 
   PUBLIC init_advect_tracer, advect_tracer
@@ -42,4 +42,5 @@
     
     DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
        CALL swap_dimensions(ind)
        CALL swap_geometry(ind)
@@ -88,19 +89,25 @@
     ENDIF
     
-!$OMP BARRIER
+!!$OMP BARRIER
 
     CALL trace_start("advect_tracer") 
 
     CALL send_message(f_u,req_u)
+    CALL wait_message(req_u)
     CALL send_message(f_wfluxt,req_wfluxt)
+    CALL wait_message(req_wfluxt)
     CALL send_message(f_q,req_q)
+    CALL wait_message(req_q)
     CALL send_message(f_rhodz,req_rhodz)
-    CALL wait_message(req_u)
-    CALL wait_message(req_wfluxt)
-    CALL wait_message(req_q)
     CALL wait_message(req_rhodz)
+
+!    CALL wait_message(req_u)
+!    CALL wait_message(req_wfluxt)
+!    CALL wait_message(req_q)
+!    CALL wait_message(req_rhodz)
     
     ! 1/2 vertical transport + back-trajectories
     DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
        CALL swap_dimensions(ind)
        CALL swap_geometry(ind)
@@ -126,10 +133,12 @@
 
     CALL send_message(f_cc,req_cc)
+    CALL wait_message(req_cc)
 
 
     ! horizontal transport - split in two to place transfer of gradq3d
-!$OMP BARRIER
+!!$OMP BARRIER
     DO k = 1, nqtot
        DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
           CALL swap_dimensions(ind)
           CALL swap_geometry(ind)
@@ -137,13 +146,14 @@
           gradq3d = f_gradq3d(ind)
           one_over_sqrt_leng=f_one_over_sqrt_leng(ind)
-          CALL compute_gradq3d(q(:,:,k),one_over_sqrt_leng,gradq3d)
+          CALL compute_gradq3d(q(:,:,k),one_over_sqrt_leng,gradq3d,xyz_i,xyz_v)
        END DO
 
        CALL send_message(f_gradq3d,req_gradq3d)
-       CALL wait_message(req_cc)
+!       CALL wait_message(req_cc)
        CALL wait_message(req_gradq3d)
 
 
        DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
           CALL swap_dimensions(ind)
           CALL swap_geometry(ind)
@@ -158,7 +168,8 @@
     
     ! 1/2 vertical transport
-!$OMP BARRIER
+!!$OMP BARRIER
 
     DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
        CALL swap_dimensions(ind)
        CALL swap_geometry(ind)
@@ -179,5 +190,5 @@
     CALL trace_end("advect_tracer")
 
-!$OMP BARRIER
+!!$OMP BARRIER
 
   END SUBROUTINE advect_tracer
@@ -227,5 +238,5 @@
 
 !--> flush dzqw, adzqw
-!$OMP BARRIER
+!!$OMP BARRIER
 
     ! minmod-limited slope of q
@@ -260,5 +271,5 @@
 
 !---> flush dzq
-!$OMP BARRIER  
+!!$OMP BARRIER  
 
     ! sigw = fraction of mass that leaves level l/l+1
@@ -292,5 +303,5 @@
 
 ! --> flush wq
-!$OMP BARRIER
+!!$OMP BARRIER
 
 
Index: codes/icosagcm/trunk/src/caldyn.f90
===================================================================
--- codes/icosagcm/trunk/src/caldyn.f90	(revision 185)
+++ codes/icosagcm/trunk/src/caldyn.f90	(revision 186)
@@ -4,4 +4,5 @@
   PRIVATE
   CHARACTER(LEN=255),SAVE :: caldyn_type
+!$OMP THREADPRIVATE(caldyn_type)
   
   PUBLIC init_caldyn, caldyn, caldyn_BC
Index: codes/icosagcm/trunk/src/caldyn_adv.f90
===================================================================
--- codes/icosagcm/trunk/src/caldyn_adv.f90	(revision 185)
+++ codes/icosagcm/trunk/src/caldyn_adv.f90	(revision 186)
@@ -27,4 +27,5 @@
 
     DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
        CALL swap_dimensions(ind)
        CALL swap_geometry(ind)
@@ -78,4 +79,5 @@
 
     DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
        CALL swap_dimensions(ind)
        CALL swap_geometry(ind)
@@ -88,7 +90,7 @@
        du=f_du(ind)
 
-       !$OMP PARALLEL DEFAULT(SHARED)
+!       !$OMP PARALLEL DEFAULT(SHARED)
        CALL compute_caldyn(ps,u,hflux, wflux, dps, dtheta_rhodz, du)
-       !$OMP END PARALLEL
+!       !$OMP END PARALLEL
     ENDDO
 
Index: codes/icosagcm/trunk/src/caldyn_gcm.f90
===================================================================
--- codes/icosagcm/trunk/src/caldyn_gcm.f90	(revision 185)
+++ codes/icosagcm/trunk/src/caldyn_gcm.f90	(revision 186)
@@ -6,5 +6,6 @@
   INTEGER, PARAMETER :: energy=1, enstrophy=2
   TYPE(t_field),POINTER :: f_out_u(:), f_qu(:), f_qv(:)
-  REAL(rstd),POINTER :: out_u(:,:), p(:,:), qu(:,:)
+  REAL(rstd),SAVE,POINTER :: out_u(:,:), p(:,:), qu(:,:)
+  !$OMP THREADPRIVATE(out_u, p, qu)
 
   TYPE(t_field),POINTER :: f_buf_i(:), f_buf_ulon(:), f_buf_ulat(:), f_buf_u3d(:)
@@ -19,5 +20,6 @@
    
   INTEGER :: caldyn_conserv
-  
+ !$OMP THREADPRIVATE(caldyn_conserv) 
+ 
   TYPE(t_message) :: req_ps, req_mass, req_theta_rhodz, req_u, req_qu
 
@@ -101,4 +103,5 @@
     IF (omp_first) THEN
        DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
           CALL swap_dimensions(ind)
           CALL swap_geometry(ind)
@@ -124,5 +127,5 @@
     ENDIF
 
-    !$OMP BARRIER
+!    !$OMP BARRIER
   END SUBROUTINE caldyn_BC
    
@@ -175,5 +178,5 @@
       IF(caldyn_eta==eta_mass) THEN
          CALL init_message(f_ps,req_i1,req_ps)
-      ELSE
+!      ELSE
          CALL init_message(f_mass,req_i1,req_mass)
       END IF
@@ -181,19 +184,35 @@
       CALL init_message(f_u,req_e1_vect,req_u)
       CALL init_message(f_qu,req_e1_scal,req_qu)
+!      IF(caldyn_eta==eta_mass) THEN
+!         CALL send_message(f_ps,req_ps) 
+!         CALL wait_message(req_ps)  
+!      ELSE
+!         CALL send_message(f_mass,req_mass) 
+!         CALL wait_message(req_mass)  
+!      END IF
+    ENDIF
+    
+    CALL trace_start("caldyn")
+
       IF(caldyn_eta==eta_mass) THEN
          CALL send_message(f_ps,req_ps) 
+         CALL wait_message(req_ps)  
       ELSE
          CALL send_message(f_mass,req_mass) 
+         CALL wait_message(req_mass)  
       END IF
-    ENDIF
-    
-    CALL trace_start("caldyn")
 
     CALL send_message(f_u,req_u)
+    CALL wait_message(req_u)
     CALL send_message(f_theta_rhodz,req_theta_rhodz) 
+    CALL wait_message(req_theta_rhodz) 
+    
+!    CALL wait_message(req_u)
+!    CALL wait_message(req_theta_rhodz) 
 
     SELECT CASE(caldyn_conserv)
     CASE(energy) ! energy-conserving
        DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
           CALL swap_dimensions(ind)
           CALL swap_geometry(ind)
@@ -209,6 +228,8 @@
 
        CALL send_message(f_qu,req_qu)
+       CALL wait_message(req_qu)
 
        DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
           CALL swap_dimensions(ind)
           CALL swap_geometry(ind)
@@ -237,4 +258,5 @@
     CASE(enstrophy) ! enstrophy-conserving
        DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
           CALL swap_dimensions(ind)
           CALL swap_geometry(ind)
@@ -267,5 +289,5 @@
     END SELECT
 
-!$OMP BARRIER
+!!$OMP BARRIER
     IF (write_out) THEN
 
@@ -289,5 +311,5 @@
     !    CALL check_mass_conservation(f_ps,f_dps)
     CALL trace_end("caldyn")
-!$OMP BARRIER
+!!$OMP BARRIER
     
 END SUBROUTINE caldyn
@@ -338,13 +360,13 @@
 
   IF(caldyn_eta==eta_mass) THEN
-     CALL wait_message(req_ps)  
+!     CALL wait_message(req_ps)  
   ELSE
-     CALL wait_message(req_mass)
+!     CALL wait_message(req_mass)
   END IF
-  CALL wait_message(req_theta_rhodz) 
+!  CALL wait_message(req_theta_rhodz) 
 
   IF(caldyn_eta==eta_mass) THEN ! Compute mass & theta
      DO l = ll_begin,ll_end
-        CALL test_message(req_u) 
+!        CALL test_message(req_u) 
 !DIR$ SIMD
         DO ij=ij_begin_ext,ij_end_ext
@@ -356,5 +378,5 @@
   ELSE ! Compute only theta
      DO l = ll_begin,ll_end
-        CALL test_message(req_u) 
+!        CALL test_message(req_u) 
 !DIR$ SIMD
        DO ij=ij_begin_ext,ij_end_ext
@@ -364,5 +386,5 @@
   END IF
 
-  CALL wait_message(req_u)   
+!  CALL wait_message(req_u)   
   
 !!! Compute shallow-water potential vorticity
@@ -427,5 +449,5 @@
 !!! Compute exner function and geopotential
        DO l = 1,llm
-          !$OMP DO SCHEDULE(STATIC) 
+!         !$OMP DO SCHEDULE(STATIC) 
           !DIR$ SIMD
           DO ij=ij_begin_ext,ij_end_ext         
@@ -448,5 +470,5 @@
           ! specific volume 1 = dphi/g/rhodz
           DO l = 1,llm
-             !$OMP DO SCHEDULE(STATIC) 
+!             !$OMP DO SCHEDULE(STATIC) 
              !DIR$ SIMD
              DO ij=ij_begin_ext,ij_end_ext         
@@ -462,5 +484,6 @@
           ! other layers
           DO l = llm-1, 1, -1
-             !$OMP DO SCHEDULE(STATIC) 
+
+!          !$OMP DO SCHEDULE(STATIC) 
              !DIR$ SIMD
              DO ij=ij_begin_ext,ij_end_ext         
@@ -475,5 +498,6 @@
           ! specific volume v = kappa*theta*pi/p = dphi/g/rhodz
           DO l = 1,llm
-             !$OMP DO SCHEDULE(STATIC) 
+
+!             !$OMP DO SCHEDULE(STATIC) 
              !DIR$ SIMD
              DO ij=ij_begin_ext,ij_end_ext         
@@ -521,9 +545,9 @@
     CALL trace_start("compute_caldyn_horiz")
 
-    CALL wait_message(req_theta_rhodz) 
+!    CALL wait_message(req_theta_rhodz) 
 
   DO l = ll_begin, ll_end
 !!!  Compute mass and theta fluxes
-    IF (caldyn_conserv==energy) CALL test_message(req_qu) 
+!    IF (caldyn_conserv==energy) CALL test_message(req_qu) 
 !DIR$ SIMD
     DO ij=ij_begin_ext,ij_end_ext         
@@ -565,5 +589,5 @@
     CASE(energy) ! energy-conserving TRiSK
 
-       CALL wait_message(req_qu)
+!       CALL wait_message(req_qu)
 
         DO l=ll_begin,ll_end
@@ -671,5 +695,5 @@
        ! other layers
        DO l = llm-1, 1, -1
-          !$OMP DO SCHEDULE(STATIC) 
+!          !$OMP DO SCHEDULE(STATIC) 
           !DIR$ SIMD
           DO ij=ij_begin_ext,ij_end_ext         
@@ -686,6 +710,7 @@
 !DIR$ SIMD
           DO ij=ij_begin,ij_end         
-                berni(ij,l) = pk(ij,l) &
-                     + 1/(4*Ai(ij))*(le(ij+u_right)*de(ij+u_right)*u(ij+u_right,l)**2 +    &
+                
+                berni(ij,l) = pk(ij,l) + &
+                       1/(4*Ai(ij))*(le(ij+u_right)*de(ij+u_right)*u(ij+u_right,l)**2 +    &
                                      le(ij+u_rup)*de(ij+u_rup)*u(ij+u_rup,l)**2 +          &
                                      le(ij+u_lup)*de(ij+u_lup)*u(ij+u_lup,l)**2 +          &
@@ -756,6 +781,6 @@
     REAL(rstd),INTENT(INOUT)  :: convm(iim*jjm,llm)  ! mass flux convergence
 
-    REAL(rstd),INTENT(OUT) :: wflux(iim*jjm,llm+1) ! vertical mass flux (kg/m2/s)
-    REAL(rstd),INTENT(OUT) :: wwuu(iim*3*jjm,llm+1)
+    REAL(rstd),INTENT(INOUT) :: wflux(iim*jjm,llm+1) ! vertical mass flux (kg/m2/s)
+    REAL(rstd),INTENT(INOUT) :: wwuu(iim*3*jjm,llm+1)
     REAL(rstd),INTENT(OUT) :: du(iim*3*jjm,llm)
     REAL(rstd),INTENT(OUT) :: dtheta_rhodz(iim*jjm,llm)
@@ -766,12 +791,16 @@
     REAL(rstd) :: p_ik, exner_ik
 
-
+!    REAL(rstd) :: wwuu(iim*3*jjm,llm+1) ! tmp var, don't know why but gain 30% on the whole code in opemp
+                                        ! need to be understood
+
+!    wwuu=wwuu_out
   CALL trace_start("compute_caldyn_vert")
 
-!$OMP BARRIER   
+!!$OMP BARRIER   
 !!! cumulate mass flux convergence from top to bottom
   DO  l = llm-1, 1, -1
-    IF (caldyn_conserv==energy) CALL test_message(req_qu) 
-!$OMP DO SCHEDULE(STATIC) 
+!    IF (caldyn_conserv==energy) CALL test_message(req_qu) 
+
+!!$OMP DO SCHEDULE(STATIC) 
 !DIR$ SIMD
     DO ij=ij_begin,ij_end         
@@ -794,5 +823,5 @@
 !!! Compute vertical mass flux (l=1,llm+1 done by caldyn_BC)
   DO l=ll_beginp1,ll_end
-    IF (caldyn_conserv==energy) CALL test_message(req_qu) 
+!    IF (caldyn_conserv==energy) CALL test_message(req_qu) 
 !DIR$ SIMD
       DO ij=ij_begin,ij_end         
@@ -828,5 +857,5 @@
 
  !--> flush wwuu  
- !$OMP BARRIER
+ ! !$OMP BARRIER
 
 ! Add vertical transport to du
@@ -839,4 +868,13 @@
     ENDDO
   ENDDO      
+
+!  DO l=ll_beginp1,ll_end
+!!DIR$ SIMD
+!      DO ij=ij_begin,ij_end         
+!        wwuu_out(ij+u_right,l) = wwuu(ij+u_right,l)
+!        wwuu_out(ij+u_lup,l)   = wwuu(ij+u_lup,l)
+!        wwuu_out(ij+u_ldown,l) = wwuu(ij+u_ldown,l)
+!     ENDDO
+!   ENDDO
   
   CALL trace_end("compute_caldyn_vert")
@@ -973,4 +1011,5 @@
 
     DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
        CALL swap_dimensions(ind)
        CALL swap_geometry(ind)
@@ -1002,4 +1041,5 @@
     
     DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
        CALL swap_dimensions(ind)
        CALL swap_geometry(ind)
